#include <stdio.h>
#include <string.h>
#include <mpi.h>

#define N 3
#define N2 (N*N)

int a[N2], b[N2], c[N2];
#define A(I,J) a[(I)*N + (J)]
#define B(I,J) b[(I)*N + (J)]
#define C(I,J) c[(I)*N + (J)]

int main(int argc, char *argv[])
{
  int size, rank, i,j,k, p[2], len;
  MPI_Status status;

  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  if (rank == 0)
  {
    for (i = 0; i < N2; i++) { a[i] = i+1; }
    for (i = 0; i < N2; i++) { b[i] = i+1; }

    MPI_Bcast(a, N2, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(b, N2, MPI_INT, 0, MPI_COMM_WORLD);

    for (i = 1; i < size; i++)
    {
      MPI_Recv(p, 2, MPI_INT, MPI_ANY_SOURCE, 30, MPI_COMM_WORLD, &status);
      MPI_Recv(c+N*p[0], N*p[1], MPI_INT, status.MPI_SOURCE, 40, MPI_COMM_WORLD, &status);
		}

    for (i = 0; i < N; i++)
    {
      for (j = 0; j < N; j++)
        printf("%i\t", C(i,j));
      printf("\n");
    } 
    printf("Finish!\n");
  }
  else
  {
    MPI_Bcast(a, N2, MPI_INT, 0, MPI_COMM_WORLD);
    MPI_Bcast(b, N2, MPI_INT, 0, MPI_COMM_WORLD);

    len = N / (size-1);
    p[0] = len * (rank-1);
    p[1] = rank < size-1 ? len*rank : N;

    for (i = p[0]; i < p[1]; i++)
    {
      for (j = 0; j < N; j++)
      {
        C(i,j) = 0;
        for (k = 0; k < N; k++)
          C(i,j) += A(i,k) * B(k,j);
      }
    }

    p[1] -= p[0];

    MPI_Send(p, 2, MPI_INT, 0, 30, MPI_COMM_WORLD);
    MPI_Send(c+N*p[0], N*p[1], MPI_INT, 0, 40, MPI_COMM_WORLD);
  }

  MPI_Finalize();
  return 0;
}
